import java.util.List;

import javax.ejb.Stateless;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.seam.security.Identity;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.contexts.Context;
import org.jboss.seam.ejb.SeamInterceptor;

@Stateless
@Name("login")
public class LoginAction implements Login
{
   
   @In
   Identity identity;

   @Out
   private User user;
   
   @PersistenceContext
   private EntityManager em;
   
   @In
   private transient Context sessionContext;
   @In
   private transient FacesContext facesContext;

   public boolean login()
   {
      List<User> results = em.createQuery("select u from User u where username=:username and password=:password")
            .setParameter("username", identity.getUsername())
            .setParameter("password", identity.getPassword())
            .getResultList();
      
      if ( results.size()==0 )
      {
         facesContext.addMessage(null, new FacesMessage("Invalid login"));
         return false;
      }
      else
      {
         user = results.get(0);
         identity.addRole("visitor");
         return true;
      }
      
   }

}
