import java.util.List;
import org.jboss.seam.annotations.*;
import org.jboss.seam.annotations.datamodel.*;
import org.hibernate.validator.Valid;

import org.hibernate.Session;

@Name("manager")
public class ManagerPojo {

  @In (required=false) @Out (required=false)
  private Person person;

  @In (create=true)
  private Session helloSession;

  Long pid;
 
  public String sayHello () {
    helloSession.save (person);
    return "fans";
  }

  @DataModel
  private List <Person> fans;

  @DataModelSelection
  private Person selectedFan;

  @Factory("fans")
  public void findFans () {
    System.out.println("Find called");
    fans = helloSession.createQuery("select p from Person p")
                                  .list();
  }

  public void setPid (Long pid) {
    this.pid = pid;
    
    if (pid != null) {
      person = (Person) helloSession.get(Person.class, pid);
    } else {
      person = new Person ();
    }
  }
  
  public Long getPid () {
    return pid;
  }

  public String delete () {
    // merge? or page scope data model?
    Person toDelete = (Person) helloSession.merge (selectedFan);
    helloSession.delete( toDelete );
    findFans ();
    return null;
  }

  public String update () {
    // The "person" component is detached since this is not
    // a long running conversation
    // Person p = em.merge (person);
    // find ();
    return "fans";
  }

}
