
import java.util.List;
import javax.ejb.*;
import org.jboss.seam.annotations.*;
import org.jboss.seam.ejb.*;

import static org.jboss.seam.ScopeType.SESSION;

import javax.persistence.*;

@Stateful
@Name("manager")
@Scope (SESSION)
public class ManagerAction implements Manager {

  @In @Out
  private Person person;

  private List <Person> fans;

  private boolean confirmed = false;

  @PersistenceContext
  private EntityManager em;

  public String sayHello () {
    System.out.println("sayHello called");
    if (person.getName()
            .matches("^[a-zA-Z.-]+ [a-zA-Z.-]+")
        || confirmed) {

      em.persist (person);
      confirmed = false;
      find ();
      return "fans";

    } else {
      // confirmed = true;
      return "warning";
    }
  }

  public String confirm () {
    confirmed = true;
    return sayHello ();
  }

  public String startOver () {
    System.out.println("startover called");
    person = new Person ();
    confirmed = false;
    return "hello";
  }

  @Create
  public void find () {
    System.out.println("Find called");
    fans = em.createQuery("select p from Person p")
             .getResultList();
  }

  @Remove @Destroy
  public void destroy() {}
  
  public List <Person> getFans () {
    return fans;
  }

}
