import javax.ejb.Stateful;
import javax.ejb.Remove;

import org.jboss.seam.ScopeType;
import org.jboss.seam.Seam;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.bpm.Actor;

@Stateful
@Name("login")
@Scope(ScopeType.SESSION)
public class LoginAction implements Login {

	@In(create = true)
	private Actor actor;

	@In
	private User user;

	public User getUser() {
		return user;
	}

	public String loginUser() {
		System.out.println("Login as user");
		actor.setId(user.getUsername());
		actor.getGroupActorIds().add("user");
		return "home";
	}

	public String loginAdmin() {
		System.out.println("Login as admin");
		actor.setId(user.getUsername());
		actor.getGroupActorIds().add("user");
		actor.getGroupActorIds().add("admin");
		return "home";
	}

	public String logout() {
		actor = null;
		user = null;
		Seam.invalidateSession();
		return "login";
	}

  @Remove @Destroy
  public void destroy() {}

}
